////////////////////////////////////////////////////////////////////
// |Ԉێ̋wKiRPUq^V~[Vj
////////////////////////////////////////////////////////////////////
#define _USE_MATH_DEFINES
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <random>
#include <iomanip>
#include <time.h>
#include <direct.h>
#include <math.h>
#include <omp.h>

#include "Vector3.h"
#include "RK4_Nbody.h"
////////////////////////////////////////////////////////////////////
// p[^
////////////////////////////////////////////////////////////////////
//͈̔
double t_min = 0;
double t_max = 5.0;
double dt = 0.001;
//d͉x
double g = 10.0;
//Ђ̒
double L = 1.0;

//d͉xxNg
Vector3 vec_g = Vector3(0, 0, -g);
//
double m_box = 100.0;
double m = 1.0;

//zPʃxNg
Vector3 z_hat(0, 0, 1);

////////////////////////////////////////////////////////////////////
// qNX
////////////////////////////////////////////////////////////////////
class Particles : public RK4_Nbody {
private:
public:
	//
	double fx = 0;

	//RXgN^
	Particles(int _N, double _dt) : RK4_Nbody(_N, _dt) {}

	//fXgN^
	~Particles() {
	}

	void A(double t, Vector3 *rs, Vector3 *vs, Vector3 *out_as) {
		for (int i = 0; i < N; i++) {
			out_as[i].set(0, 0, 0);
		}

		Vector3 a_box;
		a_box.set(fx / m_box, 0, 0);

		//xNg
		Vector3 vec_L = rs[1] - rs[0];
		//Αx
		Vector3 v_ij = vs[1] - vs[0];

		Vector3 vec_S = vec_L / (pow(vec_L.dot(z_hat), 2) / m_box - (m + m_box) / (m * m_box) * vec_L.lengthSq()) *
			(v_ij.lengthSq() + vec_g.dot(vec_L) - a_box.dot(vec_L));

		double Sz = vec_S.dot(z_hat);

		//Ԃ։x
		out_as[0] = a_box - vec_S / m_box + Sz * z_hat / m_box;
		//Uq։x
		out_as[1] = vec_g + vec_S / m;

	};
};


////////////////////////////////////////////////////////////////////
// QwK
////////////////////////////////////////////////////////////////////
//wK
const int Episode = 10000;
//όvZ̊wK
const int ave_span = 100;
//wK
double eta = 0.01;
//
double gamma = 1.0;
//×~
double epsilon = 0.9;

//
const int N_f_box = 20;
const int N_theta = 10;

//sԊԊu
double interval = 0.01;

const int averageNum = 10;
const int parallelNum = 5;

//sl֐
double Q[averageNum][N_f_box + 1][N_theta];

double f_box_min = -10.0 * m_box;
double f_box_max = 10.0 * m_box;
double theta_min = -90.0;
double theta_max = 90.0;

int getThetaindex( Particles& particles ) {
	double _theta = asin((particles.rs[1].x - particles.rs[0].x) / L) / M_PI * 180.0;

	//̈ʒuipxj
	for (int j = 0; j < N_theta; j++) {
		double theta = theta_min + (theta_max - theta_min) / N_theta * (j + 1);
		if (_theta < theta) {
			return j;
		}
	}
}

//EsV
double r_success = 0.0;
double r_failure = 0.0;

//ϊi[p
double probabilityOfSuccess[averageNum][Episode / ave_span + 1];
int timesOfSuccess[averageNum];

////////////////////////////////////////////////////////////////////
// C֐
////////////////////////////////////////////////////////////////////
int main(void) {
#ifdef _OPENMP
	std::cout << "OpenMP : Enabled (Max # of threads = " << omp_get_max_threads() << ")" << std::endl;
	omp_set_num_threads(parallelNum);
#endif

	//tH_̐
	_mkdir("output");

	std::random_device rnd; //񌈒Iȗ
	std::mt19937 mt;        //32rbgŃZkEcCX^
	mt.seed(rnd());         //̎^
	std::uniform_real_distribution<> rand_real_0_1(0, 1.0); //urand_real_0_1(mt)vPsłP̗𐶐

	std::ostringstream data1;
	std::ostringstream data2;

#pragma omp parallel for
	for (int ave = 0; ave < averageNum; ave++) {
		//QNb^IuWFNg̐
		Particles particles(2, dt);

		int success = 0;
		for (int episode = 0; episode <= Episode; episode++) {

			if (episode % 1000 == 0) {
				std::cout << "episode:" << ave << "-" << episode << std::endl;
			}

			double v0 = 2.0 * (0.5 - rand_real_0_1(mt));

			//ʒuxNgƑxxNg
			particles.rs[0].set(0, 0, 0);
			particles.vs[0].set(0, 0, 0);
			particles.rs[1].set(0, 0, L);
			particles.vs[1].set(v0, 0, 0);

			double dQ_ave = 0;
			//sCfbNX
			int n_f_box;
			int n_theta_now;

			double r_max = 0;

			int M = round((t_max - t_min) / dt);
			for (int i = 0; i <= M; i++) {
				double t = i * dt;

				if (i == 0) {

					//̏Ԃc
					n_theta_now = getThetaindex(particles);

					//^͂͂OƂȂCfbNX^
					n_f_box = N_f_box / 2;

					//Ԃ֗͂^
					particles.fx = f_box_min + (f_box_max - f_box_min) * n_f_box / N_f_box;


				}
				else if (i % int(interval / dt) == 0) {

					//s̏Ԃc
					int n_theta_next = getThetaindex(particles);
					//std::cout << t << " " << particles.rs[0].x << " " << particles.rs[0].z << " " << particles.rs[1].x << " " << particles.rs[1].z << std::endl;
					//std::cout << n_theta_next << std::endl;

					//̌vZïʒuGlM[j
					double r = m * g * particles.rs[1].z;

					//
					if (particles.rs[1].z < 0) {
						r += r_failure;
					}
					//
					if (i == M) {
						success++;
						timesOfSuccess[ave]++;
						r += r_success;
						//std::cout << success << " ";
					}

					double maxQ = 0;
					for (int j = 0; j <= N_f_box; j++) {
						if (maxQ < Q[ave][j][n_theta_next]) {
							maxQ = Q[ave][j][n_theta_next];
						}
					}

					double dQ = (r + gamma * maxQ - Q[ave][n_f_box][n_theta_now]);

					//sl֐̍XV
					Q[ave][n_f_box][n_theta_now] = Q[ave][n_f_box][n_theta_now] + eta * dQ;


					////////////////////////////////////////////////////
					//̍švZX
					////////////////////////////////////////////////////
					n_theta_now = n_theta_next;

					maxQ = 0;
					int n_f_box_max = 10000;
					for (int j = 0; j <= N_f_box; j++) {
						if (maxQ < Q[ave][j][n_theta_now]) {
							maxQ = Q[ave][j][n_theta_now];
							n_f_box_max = j;
						}
					}
					//wK̏ꍇimaxQ=0j
					if (n_f_box_max == 10000) n_f_box_max = int(floor((N_f_box + 1) * rand_real_0_1(mt)));

					//n_f_box = n_f_box_max;

					if (rand_real_0_1(mt) < epsilon) {
						//s͍ő剿lsɌ
						n_f_box = n_f_box_max;
					}
					else {
						//s̓_Ɍ
						n_f_box = int(floor((N_f_box + 1) * rand_real_0_1(mt)));
					}

					//Ԃ֗͂^
					particles.fx = f_box_min + (f_box_max - f_box_min) * n_f_box / N_f_box;

					//Gs\[hI
					if (particles.rs[1].z < 0) {
						//std::cout << ":" << t << "[s]" << std::endl;
						break;
					}
				}

				//QENb^@ɂ鎞ԔW
				particles.timeEvolution(t);

				for (int n = 0; n < 2; n++) {
					//ʒu̍XV
					particles.rs[n] = particles.rs[n] + particles.drs[n];
					//x̍XV
					particles.vs[n] = particles.vs[n] + particles.dvs[n];
				}

			}
			if (episode % ave_span == 0) {

				#pragma omp atomic
				probabilityOfSuccess[ave][episode / ave_span] += double(success) / ave_span;

				success = 0;
			}

		}
	}

	//LO̍쐬
	int ranking[averageNum];
	bool ranking_flag[averageNum];
	for (int i = 0; i < averageNum; i++) {
		ranking_flag[i] = false;
	}
	for (int i = 0; i < averageNum; i++) {
		int _times = -1;
		int _ave;
		for (int j = 0; j < averageNum; j++){
	
			if (ranking_flag[j]) continue;
			if (_times < timesOfSuccess[j]) {
				_times = timesOfSuccess[j];
				_ave = j;
			}
		}
		ranking[i] = _ave;
		ranking_flag[_ave] = true;
	}

	std::cout << "---------ʁi" << Episode << "wKj---------" << std::endl;
	for (int i = 0; i < averageNum; i++) {

		std::cout << i + 1 << " " << timesOfSuccess[ranking[i]] << "񐬌inum:" << ranking[i] << "j" << std::endl;

	}


	//t@C̐ݒ
	std::ostringstream filename1;
	filename1 << "output/20180608-ProbabilityOfSuccess_eta" << eta << "_gamma" << gamma << "_epsilon" << epsilon << ".txt";
	// t@Co̓Xg[̏
	std::ofstream ofs1(filename1.str());

	ofs1 << "#x:wK" << std::endl;
	ofs1 << "#y:" << std::endl;
	//ofs1 << "#legend:  " << std::endl;
	ofs1 << "#yrange:0 1 0.1" << std::endl;
	ofs1 << "#showLines: true true true true true" << std::endl;
	ofs1 << "#showMarkers: false false false false false" << std::endl;
	ofs1 << "#fills: false false" << std::endl;

	for (int i = 0; i <= Episode / ave_span; i++) {
		double p = 0;
		for (int j = 0; j < averageNum; j++) {
			p += probabilityOfSuccess[j][i] / averageNum;
		}
		ofs1 << i * ave_span;
		ofs1 << " " << probabilityOfSuccess[ranking[0]][i];
		ofs1 << " " << probabilityOfSuccess[ranking[averageNum-1]][i];
		ofs1 << " " << p << std::endl;
	}
	ofs1.close();


	//std::cout << "------------------------------" << std::endl;
	//for (int j0 = 0; j0 < N_theta; j0++) {
	//	std::cout << "ԁF" << j0 << std::endl;

	//	for (int j1 = 0; j1 <= N_f_box; j1++) {
	//		std::cout << " " << Q[j1][j0];
	//	}
	//	std::cout << std::endl;
	//}


	std::cout << "finished" << std::endl;

	int a;
	std::cin >> a;
	return a;

}

/*
gccRpC
g++ -c Vector3.cpp -std=c++14 -O2
g++ -c RK4_Nbody.cpp -std=c++14 -O2
g++ -c main.cpp -std=c++14 -O2
g++ main.o Vector3.o RK4_Nbody.o
*/
